var express = require('express');
var router = express.Router();
const passport = require('../passport-config');
const models = require('../schemas/models');

const User = models.User;
/* GET home page. */
router.get('/', function(req, res, next) {
    res.redirect('/announcements');
});

router.get('/authentification', function(req, res, next) {
    res.render('authentification');
});

router.post('/authentification', passport.authenticate('local', {
    successRedirect: '/announcements',
    failureRedirect: '/authentification'
}));

router.get('/dashboard', isAuthenticated, function(req, res, next) {
    res.render('deconnexion');
});

router.get('/register', function(req, res) {
    res.render('register', { });
});

router.post('/register', async function(req, res) {
  /*User.register(new User({ username : req.body.username }), req.body.password, function(err, account) {
          if (err) {
            return res.render('register', { account : account });
          }
      
          passport.authenticate('local')(req, res, function () {
            res.redirect('/');
          });
        });"*/
  try {
    const { username, password } = req.body;
    const existingUser = await User.findOne({ username });

    if (existingUser) {
      return res.render('register', { error: 'Cet utilisateur existe déjà.' });
    }

    const newUser = new User({
                    username: username,
                    password: password 
                  });
    await newUser.save();

    // passport.authenticate('local')(req, res, function () {
    res.redirect('/authentification');
    //});
  } catch (error) {
    res.render('register', { error: error.message });
  }
});

router.get('/logout', isAuthenticated, function(req, res, next) {
    req.logout(function(err) {
        if (err) {
            return next(err);
        }
        res.redirect('/');
    });
});

function isAuthenticated(req, res, next) {
    if (req.isAuthenticated()) {
        return next();
    }
    res.redirect('/authentification');
}

module.exports = {
    router: router,
    isAuthenticated: isAuthenticated
};